src/Entity/Presentation.php
<?php

namespace App\Entity;

use App\Repository\PresentationRepository;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: PresentationRepository::class)]
class Presentation
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 100, nullable: true)]
    private $titre_pres;

    #[ORM\Column(type: 'text', nullable: true)]
    private $paragraphe1_pres;

    #[ORM\Column(type: 'text', nullable: true)]
    private $paragraphe2_pres;

    #[ORM\Column(type: 'text', nullable: true)]
    private $paragraphe3_pres;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $image_pres_1;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $image_pres_2;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitrePres(): ?string
    {
        return $this->titre_pres;
    }

    public function setTitrePres(?string $titre_pres): self
    {
        $this->titre_pres = $titre_pres;

        return $this;
    }

    public function getParagraphe1Pres(): ?string
    {
        return $this->paragraphe1_pres;
    }

    public function setParagraphe1Pres(?string $paragraphe1_pres): self
    {
        $this->paragraphe1_pres = $paragraphe1_pres;

        return $this;
    }

    public function getParagraphe2Pres(): ?string
    {
        return $this->paragraphe2_pres;
    }

    public function setParagraphe2Pres(?string $paragraphe2_pres): self
    {
        $this->paragraphe2_pres = $paragraphe2_pres;

        return $this;
    }

    public function getParagraphe3Pres(): ?string
    {
        return $this->paragraphe3_pres;
    }

    public function setParagraphe3Pres(?string $paragraphe3_pres): self
    {
        $this->paragraphe3_pres = $paragraphe3_pres;

        return $this;
    }

    public function getImagePres1(): ?string
    {
        return $this->image_pres_1;
    }

    public function setImagePres1(?string $image_pres_1): self
    {
        $this->image_pres_1 = $image_pres_1;

        return $this;
    }

    public function getImagePres2(): ?string
    {
        return $this->image_pres_2;
    }

    public function setImagePres2(?string $image_pres_2): self
    {
        $this->image_pres_2 = $image_pres_2;

        return $this;
    }
}

src/Form/PresentationType.php
<?php

namespace App\Form;

use App\Entity\Presentation;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Validator\Constraints\File;

class PresentationType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('titre_pres', TextType::class, [
                'attr' => [
                    'class' => 'input-form',
                    'min' => '2',
                    'max' => '100'
                ],
                'label' => 'Titre',
                'label_attr' => [
                    'class' => 'label'
                ],
                'constraints' => [
                    new Assert\Length(['min' => 2, 'max' => 100]),
                    new Assert\NotBlank([
                        'message' => "Veuillez entrer un titre",
                    ])
                ]
            ])
            ->add('paragraphe1_pres', TextareaType::class, [
                'attr' => [
                    'class' => 'input-form',
                    'min' => '10',
                    'max' => '1500'
                ],
                'label' => 'Paragraphe n°1',
                'label_attr' => [
                    'class' => 'label'
                ],
                'constraints' => [
                    new Assert\Length(['min' => 10, 'max' => 1500]),
                    new Assert\NotBlank([
                        'message' => "Veuillez entrer une description",
                    ])
                ]
            ])
            ->add('image_pres_1', FileType::class, [
                'mapped' => false,
                'required' => false, 'constraints' => [
                    new File([
                        'mimeTypes' => ['image/*']
                    ])
                ]
            ])
            ->add('paragraphe2_pres', TextareaType::class, [
                'attr' => [
                    'class' => 'input-form',
                    'min' => '10',
                    'max' => '1500'
                ],
                'label' => 'Paragraphe n°2',
                'label_attr' => [
                    'class' => 'label'
                ],
                'constraints' => [
                    new Assert\Length(['min' => 10, 'max' => 1500]),
                    new Assert\NotBlank([
                        'message' => "Veuillez entrer une description",
                    ])
                ]
            ])
            ->add('image_pres_2', FileType::class, [
                'mapped' => false,
                'required' => false, 'constraints' => [
                    new File([
                        'mimeTypes' => ['image/*']
                    ])
                ]
            ])
            ->add('paragraphe3_pres', TextareaType::class, [
                'attr' => [
                    'class' => 'input-form',
                    'min' => '10',
                    'max' => '1500'
                ],
                'label' => 'Paragraphe n°3',
                'label_attr' => [
                    'class' => 'label'
                ],
                'constraints' => [
                    new Assert\Length(['min' => 10, 'max' => 1500]),
                    new Assert\NotBlank([
                        'message' => "Veuillez entrer une description",
                    ])
                ]
            ]);
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Presentation::class,
        ]);
    }
}

src/Controller/PresentationController.php
<?php

namespace App\Controller;

use App\Entity\Presentation;
use App\Form\PresentationType;
use App\Repository\PresentationRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Service\FileUploader;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;

#[Route('/presentation')]
class PresentationController extends AbstractController
{
    #[Route('/', name: 'app_presentation_index', methods: ['GET'])]
    public function index(PresentationRepository $presentationRepository): Response
    {
        return $this->render('presentation/index.html.twig', [
            'presentations' => $presentationRepository->findAll(),
        ]);
    }
    #[Security("is_granted('ROLE_ADMIN')")]
    #[Route('/new', name: 'app_presentation_new', methods: ['GET', 'POST'])]
    public function new(Request $request, FileUploader $fileUploader, PresentationRepository $presentationRepository): Response
    {
        $presentation = new Presentation();
        $form = $this->createForm(PresentationType::class, $presentation);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $imageFile1 = $form->get('image_pres_1')->getData();
            $imageFile2 = $form->get('image_pres_2')->getData();
            if ($imageFile1 && $imageFile2) {
                $imageFileName1 = $fileUploader->upload($imageFile1);
                $imageFileName2 = $fileUploader->upload($imageFile2);

                $presentation->setImagePres1($imageFileName1);
                $presentation->setImagePres2($imageFileName2);
            }

            $presentationRepository->add($presentation);
            return $this->redirectToRoute('app_presentation_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('presentation/new.html.twig', [
            'presentation' => $presentation,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_presentation_show', methods: ['GET'])]
    public function show(Presentation $presentation): Response
    {
        return $this->render('presentation/show.html.twig', [
            'presentation' => $presentation,
        ]);
    }
    #[Security("is_granted('ROLE_ADMIN')")]
    #[Route('/{id}/edit', name: 'app_presentation_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, FileUploader $fileUploader, Presentation $presentation, PresentationRepository $presentationRepository): Response
    {
        $form = $this->createForm(PresentationType::class, $presentation);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $imageFile1 = $form->get('image_pres_1')->getData();
            $imageFile2 = $form->get('image_pres_2')->getData();
            if ($imageFile1 && $imageFile2) {
                $imageFileName1 = $fileUploader->upload($imageFile1);
                $imageFileName2 = $fileUploader->upload($imageFile2);

                $presentation->setImagePres1($imageFileName1);
                $presentation->setImagePres2($imageFileName2);
            }
            $presentationRepository->add($presentation);
            return $this->redirectToRoute('app_presentation_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('presentation/edit.html.twig', [
            'presentation' => $presentation,
            'form' => $form,
        ]);
    }
    #[Security("is_granted('ROLE_ADMIN')")]
    #[Route('/{id}', name: 'app_presentation_delete', methods: ['POST'])]
    public function delete(Request $request, Presentation $presentation, PresentationRepository $presentationRepository): Response
    {
        if ($this->isCsrfTokenValid('delete'.$presentation->getId(), $request->request->get('_token'))) {
            $presentationRepository->remove($presentation);
        }

        return $this->redirectToRoute('app_presentation_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/presentation/_delete_form.html.twig
<form method="post" action="{{ path('app_presentation_delete', {'id': presentation.id}) }}" onsubmit="return confirm('Êtes-vous sûr de vouloir supprimer?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ presentation.id) }}">
    <button class="btn">Supprimer</button>
</form>

templates/presentation/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Sauvegarder') }}</button>
{{ form_end(form) }}

templates/presentation/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Modifier Présentation{% endblock %}

{% block body %}
    <h1>Modifier Présentation</h1>

    {{ include('presentation/_form.html.twig', {'button_label': 'Sauvegarde'}) }}

    <a href="{{ path('app_presentation_index') }}">Retour</a>

    {{ include('presentation/_delete_form.html.twig') }}
{% endblock %}

templates/presentation/index.html.twig
{% extends 'base.html.twig' %}


{% block title %}Présentation
{% endblock %}

{% block body %}

	<div id="bodyProposDiv">
		<main class="mainPropos">

			{% for presentation in presentations %}
				<h2 class="h1Apropos">{{ presentation.titrePres }}</h2>
				{% if is_granted('ROLE_ADMIN') %}
				<div class="input-admin">
					<a title="Nouveau" href="{{ path('app_presentation_new') }}">
						<i class="fa-solid fa-file-circle-plus fa-2x" style="color:black"></i>
					</a>
					<a title="Modifier" href="{{ path('app_presentation_edit', {'id': presentation.id}) }}">
						<i class="fa-solid fa-file-pen fa-2x" style="color:black"></i>
					</a>
				</div>
				{% endif %}

				<p class="textPropos">{{ presentation.paragraphe1Pres }}</p>
				<img class="imgPropos" src="/uploads/{{ presentation.ImagePres1 }}" alt="Premiere image"/>
				<p class="textPropos">{{ presentation.paragraphe2Pres }}</p>
				<img class="imgPropos" src="/uploads/{{ presentation.ImagePres2 }}" alt="Deuxieme image"/>
				<p class="textPropos">{{ presentation.paragraphe3Pres }}</p>

			{% else %}
            {% if is_granted('ROLE_ADMIN') %}
                <a title="Nouveau" href="{{ path('app_presentation_new') }}">
                    <i class="fa-solid fa-file-circle-plus fa-2x" style="color:black"></i>
                </a>
            {% endif %}
				<p>Aucune description, veuillez créer une description</p>
			{% endfor %}
		</main>
	</div>

{% endblock %}

templates/presentation/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Presentation{% endblock %}

{% block body %}
    <h1>Create new Presentation</h1>

    {{ include('presentation/_form.html.twig') }}

    <a href="{{ path('app_presentation_index') }}">back to list</a>
{% endblock %}

templates/presentation/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Presentation{% endblock %}

{% block body %}
    <h1>Presentation</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ presentation.id }}</td>
            </tr>
            <tr>
                <th>Titre_pres</th>
                <td>{{ presentation.titrePres }}</td>
            </tr>
            <tr>
                <th>Paragraphe1_pres</th>
                <td>{{ presentation.paragraphe1Pres }}</td>
            </tr>
            <tr>
                <th>Paragraphe2_pres</th>
                <td>{{ presentation.paragraphe2Pres }}</td>
            </tr>
            <tr>
                <th>Paragraphe3_pres</th>
                <td>{{ presentation.paragraphe3Pres }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_presentation_index') }}">back to list</a>

    <a href="{{ path('app_presentation_edit', {'id': presentation.id}) }}">edit</a>

    {{ include('presentation/_delete_form.html.twig') }}
{% endblock %}